/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.amap.api.col.3sl.dx
 *  com.amap.api.col.3sl.ly
 *  com.amap.api.col.3sl.lz
 *  com.amap.api.maps.AMap
 *  com.amap.api.maps.AMapUtils
 *  com.amap.api.maps.model.BitmapDescriptor
 *  com.amap.api.maps.model.CameraPosition
 *  com.amap.api.maps.model.LatLng
 *  com.amap.api.maps.model.Marker
 *  com.amap.api.maps.model.MarkerOptions
 *  com.amap.api.maps.utils.overlay.SmoothMoveMarker$MoveListener
 *  com.amap.api.maps.utils.overlay.SmoothMoveMarker$a
 *  com.amap.api.maps.utils.overlay.SmoothMoveMarker$b
 *  com.autonavi.amap.mapcore.IPoint
 *  com.autonavi.amap.mapcore.MapProjection
 */
package com.amap.api.maps.utils.overlay;

import com.amap.api.col.3sl.dx;
import com.amap.api.col.3sl.ly;
import com.amap.api.col.3sl.lz;
import com.amap.api.maps.AMap;
import com.amap.api.maps.AMapUtils;
import com.amap.api.maps.model.BitmapDescriptor;
import com.amap.api.maps.model.CameraPosition;
import com.amap.api.maps.model.LatLng;
import com.amap.api.maps.model.Marker;
import com.amap.api.maps.model.MarkerOptions;
import com.amap.api.maps.utils.overlay.SmoothMoveMarker;
import com.autonavi.amap.mapcore.IPoint;
import com.autonavi.amap.mapcore.MapProjection;
import java.util.LinkedList;
import java.util.List;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.atomic.AtomicBoolean;

public class SmoothMoveMarker {
    public static final float MIN_OFFSET_DISTANCE = 5.0f;
    private AMap mAMap;
    private long duration = 10000L;
    private long mStepDuration = 20L;
    private LinkedList<LatLng> points = new LinkedList();
    private LinkedList<Double> eachDistance = new LinkedList();
    private double totalDistance = 0.0;
    private double remainDistance = 0.0;
    private ly mThreadPools;
    private Object mLock = new Object();
    private Marker marker = null;
    private BitmapDescriptor descriptor;
    private int index = 0;
    private boolean useDefaultDescriptor = false;
    AtomicBoolean exitFlag = new AtomicBoolean(false);
    private MoveListener moveListener;
    private a moveStatus = a.a;
    private long pauseMillis;
    private long mAnimationBeginTime = System.currentTimeMillis();

    public SmoothMoveMarker(AMap aMap) {
        this.mAMap = aMap;
        this.mThreadPools = dx.a((String)"AMapSmoothMoveMarkerThread");
    }

    /*
     * WARNING - Removed try catching itself - possible behaviour change.
     */
    public void setPoints(List<LatLng> object) {
        Object object2 = this.mLock;
        synchronized (object2) {
            try {
                if (object == null || object.size() < 2) {
                    return;
                }
                this.stopMove();
                this.points.clear();
                object = object.iterator();
                while (object.hasNext()) {
                    LatLng latLng = (LatLng)object.next();
                    if (latLng == null) continue;
                    this.points.add(latLng);
                }
                this.eachDistance.clear();
                this.totalDistance = 0.0;
                for (int i = 0; i < this.points.size() - 1; ++i) {
                    double d = AMapUtils.calculateLineDistance((LatLng)this.points.get(i), (LatLng)this.points.get(i + 1));
                    this.eachDistance.add(d);
                    this.totalDistance += d;
                }
                this.remainDistance = this.totalDistance;
                LatLng latLng = this.points.get(0);
                if (this.marker != null) {
                    this.marker.setPosition(latLng);
                    this.checkMarkerIcon();
                } else {
                    if (this.descriptor == null) {
                        this.useDefaultDescriptor = true;
                    }
                    this.marker = this.mAMap.addMarker(new MarkerOptions().belowMaskLayer(true).position(latLng).icon(this.descriptor).title("").anchor(0.5f, 0.5f));
                }
                this.reset();
            }
            catch (Throwable throwable) {
                throwable.printStackTrace();
            }
            return;
        }
    }

    private void reset() {
        try {
            if (this.moveStatus == a.c || this.moveStatus == a.d) {
                this.exitFlag.set(true);
                this.mThreadPools.a(this.mStepDuration + 20L, TimeUnit.MILLISECONDS);
                if (this.marker != null) {
                    this.marker.setAnimation(null);
                }
                this.moveStatus = a.a;
            }
            return;
        }
        catch (Exception exception) {
            exception.printStackTrace();
            return;
        }
    }

    private void checkMarkerIcon() {
        if (this.useDefaultDescriptor) {
            if (this.descriptor == null) {
                this.useDefaultDescriptor = true;
                return;
            }
            this.marker.setIcon(this.descriptor);
            this.useDefaultDescriptor = false;
        }
    }

    public void setTotalDuration(int n) {
        this.duration = n * 1000;
    }

    public void startSmoothMove() {
        if (this.moveStatus == a.d) {
            this.moveStatus = a.c;
            long l = System.currentTimeMillis() - this.pauseMillis;
            this.mAnimationBeginTime += l;
            return;
        }
        if (this.moveStatus == a.a || this.moveStatus == a.e) {
            if (this.points.size() <= 0) {
                return;
            }
            this.index = 0;
            try {
                this.mThreadPools.a((lz)new b(this, 0));
                return;
            }
            catch (Throwable throwable) {
                throwable.printStackTrace();
            }
        }
    }

    private IPoint getCurPosition(long l) {
        if (l > this.duration) {
            this.exitFlag.set(true);
            IPoint iPoint = new IPoint();
            this.index = this.points.size() - 1;
            LatLng latLng = this.points.get(this.index);
            --this.index;
            this.index = Math.max(this.index, 0);
            this.remainDistance = 0.0;
            MapProjection.lonlat2Geo((double)latLng.longitude, (double)latLng.latitude, (IPoint)iPoint);
            if (this.moveListener != null) {
                this.moveListener.move(this.remainDistance);
            }
            return iPoint;
        }
        double d = (double)l * this.totalDistance / (double)this.duration;
        this.remainDistance = this.totalDistance - d;
        int n = 0;
        double d2 = 1.0;
        for (int i = 0; i < this.eachDistance.size(); ++i) {
            double d3 = this.eachDistance.get(i);
            if (d > d3) {
                d -= d3;
                continue;
            }
            if (d3 > 0.0) {
                d2 = d / d3;
            }
            n = i;
            break;
        }
        if (n != this.index && this.moveListener != null) {
            this.moveListener.move(this.remainDistance);
        }
        this.index = n;
        LatLng latLng = this.points.get(n);
        LatLng latLng2 = this.points.get(n + 1);
        IPoint iPoint = new IPoint();
        MapProjection.lonlat2Geo((double)latLng.longitude, (double)latLng.latitude, (IPoint)iPoint);
        IPoint iPoint2 = new IPoint();
        MapProjection.lonlat2Geo((double)latLng2.longitude, (double)latLng2.latitude, (IPoint)iPoint2);
        int n2 = iPoint2.x - iPoint.x;
        int n3 = iPoint2.y - iPoint.y;
        if (AMapUtils.calculateLineDistance((LatLng)latLng, (LatLng)latLng2) > 5.0f) {
            float f = this.getRotate(iPoint, iPoint2);
            if (this.mAMap != null && (latLng = this.mAMap.getCameraPosition()) != null) {
                this.marker.setRotateAngle(360.0f - f + latLng.bearing);
            }
        }
        return new IPoint((int)((double)iPoint.x + (double)n2 * d2), (int)((double)iPoint.y + (double)n3 * d2));
    }

    private float getRotate(IPoint iPoint, IPoint iPoint2) {
        if (iPoint == null || iPoint2 == null) {
            return 0.0f;
        }
        double d = iPoint2.y;
        double d2 = iPoint.y;
        double d3 = iPoint.x;
        return (float)(Math.atan2((double)iPoint2.x - d3, d2 - d) / Math.PI * 180.0);
    }

    public void stopMove() {
        if (this.moveStatus == a.c) {
            this.moveStatus = a.d;
            this.pauseMillis = System.currentTimeMillis();
        }
    }

    public Marker getMarker() {
        return this.marker;
    }

    public LatLng getPosition() {
        if (this.marker == null) {
            return null;
        }
        return this.marker.getPosition();
    }

    public int getIndex() {
        return this.index;
    }

    public void resetIndex() {
        this.index = 0;
    }

    /*
     * WARNING - Removed try catching itself - possible behaviour change.
     */
    public void destroy() {
        try {
            this.reset();
            this.mThreadPools.e();
            if (this.descriptor != null) {
                this.descriptor.recycle();
            }
            if (this.marker != null) {
                this.marker.destroy();
                this.marker = null;
            }
            Object object = this.mLock;
            synchronized (object) {
                this.points.clear();
                this.eachDistance.clear();
                return;
            }
        }
        catch (Throwable throwable) {
            throwable.printStackTrace();
            return;
        }
    }

    public void removeMarker() {
        if (this.marker != null) {
            this.marker.remove();
            this.marker = null;
        }
        this.points.clear();
        this.eachDistance.clear();
    }

    public void setPosition(LatLng latLng) {
        if (this.marker != null) {
            this.marker.setPosition(latLng);
            this.checkMarkerIcon();
            return;
        }
        if (this.descriptor == null) {
            this.useDefaultDescriptor = true;
        }
        this.marker = this.mAMap.addMarker(new MarkerOptions().belowMaskLayer(true).position(latLng).icon(this.descriptor).title("").anchor(0.5f, 0.5f));
    }

    public void setDescriptor(BitmapDescriptor bitmapDescriptor) {
        if (this.descriptor != null) {
            this.descriptor.recycle();
        }
        this.descriptor = bitmapDescriptor;
        if (this.marker != null) {
            this.marker.setIcon(bitmapDescriptor);
        }
    }

    public void setRotate(float f) {
        CameraPosition cameraPosition;
        if (this.marker != null && this.mAMap != null && this.mAMap != null && (cameraPosition = this.mAMap.getCameraPosition()) != null) {
            this.marker.setRotateAngle(360.0f - f + cameraPosition.bearing);
        }
    }

    public void setVisible(boolean bl) {
        if (this.marker != null) {
            this.marker.setVisible(bl);
        }
    }

    public void setMoveListener(MoveListener moveListener) {
        this.moveListener = moveListener;
    }

    static /* synthetic */ long access$102(SmoothMoveMarker smoothMoveMarker, long l) {
        smoothMoveMarker.mAnimationBeginTime = l;
        return smoothMoveMarker.mAnimationBeginTime;
    }

    static /* synthetic */ a access$202(SmoothMoveMarker smoothMoveMarker, a a2) {
        smoothMoveMarker.moveStatus = a2;
        return smoothMoveMarker.moveStatus;
    }

    static /* synthetic */ int access$300(SmoothMoveMarker smoothMoveMarker) {
        return smoothMoveMarker.index;
    }

    static /* synthetic */ LinkedList access$400(SmoothMoveMarker smoothMoveMarker) {
        return smoothMoveMarker.points;
    }

    static /* synthetic */ Object access$500(SmoothMoveMarker smoothMoveMarker) {
        return smoothMoveMarker.mLock;
    }

    static /* synthetic */ a access$200(SmoothMoveMarker smoothMoveMarker) {
        return smoothMoveMarker.moveStatus;
    }

    static /* synthetic */ long access$100(SmoothMoveMarker smoothMoveMarker) {
        return smoothMoveMarker.mAnimationBeginTime;
    }

    static /* synthetic */ IPoint access$600(SmoothMoveMarker smoothMoveMarker, long l) {
        return smoothMoveMarker.getCurPosition(l);
    }

    static /* synthetic */ Marker access$700(SmoothMoveMarker smoothMoveMarker) {
        return smoothMoveMarker.marker;
    }

    static /* synthetic */ long access$800(SmoothMoveMarker smoothMoveMarker) {
        return smoothMoveMarker.mStepDuration;
    }
}
